#!/usr/bin/perl

use DBI;
use mapscript;

$file = 'polygon';
$shape_type = $mapscript::MS_SHP_POLYGON;
$layer_type = $mapscript::MS_POLYGON;

system('rm *.shp *.shx *.dbf'); # remove old files

# create the shapefile
$shapefile = new shapefileObj($file, $shape_type) or die "Unable to create shapefile '$file'. ", $mapscript::ms_error->{message};

# create the xbase file
$dbh = DBI->connect("DBI:XBase:./");
$sth = $dbh->prepare("create table $file ( id int, comment char(100) )");
$sth->execute() or die $sth->errstr();

# now create a few shapes
$point = new pointObj();
$line = new lineObj();
$shape = new shapeObj();

$point->{x} = 50;
$point->{y} = 50;
$line->add($point);
$point->{x} = 100;
$point->{y} = 100;
$line->add($point);
$point->{x} = 0;
$point->{y} = 100;
$line->add($point);
$point->{x} = 50;
$point->{y} = 50;
$line->add($point);

$shape->add($line);

$line = new lineObj();

$point->{x} = 50;
$point->{y} = 60;
$line->add($point);
$point->{x} = 80;
$point->{y} = 90;
$line->add($point);
$point->{x} = 20;
$point->{y} = 90;
$line->add($point);
$point->{x} = 50;
$point->{y} = 60;
$line->add($point);

$shape->add($line);

$shapefile->add($shape);

$sth = $dbh->prepare("insert into $file values (0, 'shape 1')");
$sth->execute() or die $sth->errstr();

$shapefile = ''; # causes the header to be re-written

# now let's render it
$map = new mapObj("create.map") or die "Unable to load map file. ", $mapscript::ms_error->{message};

# mess with the layer parameters
$layer = $map->getLayerByName('new') or die "Can't find layer 'new'.", $mapscript::ms_error->{message};
$layer->{data} = $file;
$layer->{type} = $layer_type;
$layer->{labelitem} = 'comment';
$layer->{annotate} = 1;

$class = $layer->getClass(0);
$class->{label}->{color} = $map->addColor(0,0,0);
$class->{label}->{size} = $mapscript::MS_GD_TINY;

$img = $map->draw() or die "Unable to render map.", $mapscript::ms_error->{message};
mapscript::msSaveImage($img,"test.gif",1,1);
